#!/usr/bin/perl

###############################################################################
#
# MailScanner patch for SQL Black/-Whitelists
#                       (www.mailscanner.info)
#
# Copyright (c) by  Oliver Pitzeier, June 2003
#               by  oliver@linux-kernel.at
#
# Changes are welcome, but please inform me about those!
#
###############################################################################

###############################################################################
#
# $Id: blackwhitelist.pl,v 1.2 2003/06/17 09:48:57 oliver Exp $
#
# $Log: blackwhitelist.pl,v $
# Revision 1.2  2003/06/17 09:48:57  oliver
# +/- Changed test routine to show up regex example
#
# Revision 1.1.1.1  2003/06/11 13:58:29  oliver
# Initial import...
#
#
#
###############################################################################

use strict;
use warnings;
use DBI;

# User defineable values
my $database  = 'mailscanner';
my $hostname  = 'localhost';
my $username  = 'root';
my $password  = '';

# Enable this only if you want TEST OUTPUT!
my $TEST      = '1';

# You don't have to change this, unless you have changed the database layout
my $to_mail   = 'to_mail';
my $from_mail = 'from_mail';

# Keep in mind, that you MUST have the DBD::$db_type installed!!!
# Eg. DBD::mysql, DBD::Pg
my $db_type   = 'mysql';
# Port: 3306 for mysql, 5432 for Pg, ...
my $db_port   = '3306';

# Non-user defineable values
my $dsn = "DBI:$db_type:database=$database;host=$hostname;db_port=$db_port";
my %list_hash;

# Connect to the database
my $dbh = DBI->connect($dsn, $username, $password); 

my $sth = $dbh->prepare("SELECT * FROM blacklist ORDER BY $to_mail");
$sth->execute();

while (my $ref = $sth->fetchrow_hashref()) {
#    print "Found a row: $ref->{'to_mail'}, $ref->{'from_mail'}\n";
    $list_hash{lc($ref->{'to_mail'})}{lc($ref->{'from_mail'})} = 1;
}

# Disconnect from the database;
$dbh->disconnect;

if($TEST) {
    # Test if data is read correct
    foreach my $from_address (sort keys %list_hash) {
        print "User \'$from_address\' doesn\'t like spam from:\n";
        my $from_hash_h = $list_hash{$from_address};
        foreach my $to_address (sort keys %$from_hash_h) {
            print " "x5;
            print $to_address;
            print "\n";
        }
    }


    # Does 'testuser@bla.com' like spam from 'testuser@bla.com'?
    # This is now simply testable this way:

    print "testuser\@bla.com likes spam from \'testuser\@bla.com\'?\n";
    my $helper = $list_hash{'testuser@bla.com'};
    foreach my $match (keys %$helper) {
        $match =~ s/\@/\\@/g;
        $match =~ s/\+/\\+/g;
        $match =~ s/\./\\./g;
        $match =~ s/\*/.*/g;
        $match =~ s/\?/./g;
        print "No ($match)\n"     if 'testuser@bla.com' =~ m/$match/;
        print "   ($match)\n" unless 'testuser@bla.com' =~ m/$match/;
    }
}
